use crate::interaction::Interaction;
use std::io::Write;

pub struct CommandLine {}

impl CommandLine {
    pub fn new() -> Self {
        Self {}
    }
}

impl Interaction for CommandLine {
    fn input(&self) -> Result<String, String> {
        let buffer: &mut String = &mut String::new();
        if let Ok(_) = std::io::stdin().read_line(buffer) {
            return Ok(buffer.to_string());
        } else {
            return Err(String::from("could not read input buffer"));
        }
    }

    fn output(&self, output: String) {
        let _ = std::io::stdout().write(output.as_bytes());
        let _ = std::io::stdout().flush();
    }
}
