use std::ops::{Deref, DerefMut};

#[derive(Debug, Clone)]
pub struct Page {
    buffer: Vec<u8>,
}

impl Page {
    pub fn new(buffer: Vec<u8>) -> Self {
        Self { buffer }
    }
}

impl Deref for Page {
    type Target = Vec<u8>;

    fn deref(&self) -> &Self::Target {
        &self.buffer
    }
}

impl DerefMut for Page {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.buffer
    }
}
